#!/usr/bin/env python

import hal
import hal_glib
import gtk
import glib
import time
import linuxcnc
from hal_glib import GStat, GPin
GSTAT = GStat()
CMD = linuxcnc.command()

class HandlerClass:


#    def on_led_change(self,hal_led,data=None):
#        '''
#        the gladevcp.change led had a transition
#        '''
#        if hal_led.hal_pin.get():
#            if self.halcomp["number"] > 0.0:
#                self.change_text.set_label("Insert too number %d" % (int(self.halcomp["number"])))
#            else:
#                self.change_text.set_label("Remove tool")
#        else:
#            self.change_text.set_label("")         



    def __init__(self, halcomp,builder,useropts):
        self.halcomp = halcomp
        self.builder = builder
#        self.change_text = builder.get_object("change-text")
#        self.halcomp.newpin("number", hal.HAL_FLOAT, hal.HAL_IN)

        GSTAT.connect("state-estop",lambda w: self.update_estate_label('Emergency is pressed! Need to Reset!'))
        GSTAT.connect("state-estop-reset",lambda w: self.update_estate_label('Healty'))

        GSTAT.connect("state-on",lambda w: self.update_state_label('Machine is ON '))
        GSTAT.connect("state-off",lambda w: self.update_state_label('Machine is OFF'))

        GSTAT.connect("interp-paused",lambda w: self.update_interp_label('Paused '))
        GSTAT.connect("interp-run",lambda w: self.update_interp_label('Running'))
        GSTAT.connect("interp-idle",lambda w: self.update_interp_label('Idle   '))

        self.on_trigger1 = GPin(halcomp.newpin('spindle-on-trigger', hal.HAL_BIT, hal.HAL_OUT))
        self.on_trigger2 = GPin(halcomp.newpin('aspirator-on-trigger', hal.HAL_BIT, hal.HAL_OUT))
        self.on_trigger3 = GPin(halcomp.newpin('flood-on-trigger', hal.HAL_BIT, hal.HAL_OUT))

        self.off_trigger1 = GPin(halcomp.newpin('spindle-off-trigger', hal.HAL_BIT, hal.HAL_OUT))
        self.off_trigger2 = GPin(halcomp.newpin('aspirator-off-trigger', hal.HAL_BIT, hal.HAL_OUT))
        self.off_trigger3 = GPin(halcomp.newpin('flood-off-trigger', hal.HAL_BIT, hal.HAL_OUT))

    def update_state_label(self,text):
        self.builder.get_object('state_label').set_label("%s" % (text))

    def update_estate_label(self,text):
        self.builder.get_object('e_state_label').set_label("%s" % (text))

    def update_interp_label(self,text):
        self.builder.get_object('interp_state_label').set_label("Interpreter is %s" % (text))

    def update_popup_label(self,text):
        self.builder.get_object('hal_label1').set_label("xxx-%s" % (text))

    def spindle_pressed(self, obj):
        state = True
	CMD.spindle(linuxcnc.SPINDLE_FORWARD)
        # is spindle already enabled?
        if GSTAT.stat.spindle_enabled:
            state = False
	    CMD.spindle(linuxcnc.SPINDLE_OFF)
        # toggle HAL pins to command HALUI
        self.on_trigger1.set(state)
        self.off_trigger1.set(not state)

    def aspirator_pressed(self, obj):
        state = True
	CMD.mist(linuxcnc.MIST_ON)
        # is mist already enabled?
        if GSTAT.stat.mist:
            state = False
	    CMD.mist(linuxcnc.MIST_OFF)
        # toggle HAL pins to command HALUI
        self.on_trigger2.set(state)
        self.off_trigger2.set(not state)

    def flood_pressed(self, obj):
        state = True
	CMD.flood(linuxcnc.FLOOD_ON)
        # is flood already enabled?
        if GSTAT.stat.flood:
            state = False
	    CMD.flood(linuxcnc.FLOOD_OFF)
        # toggle HAL pins to command HALUI
        self.on_trigger3.set(state)
        self.off_trigger3.set(not state)

def get_handlers(halcomp,builder,useropts):
    return [HandlerClass(halcomp,builder,useropts)]

